echo "*************************************"
echo "* Upgrading"  

if [ $# -ne 2 ]
then
   echo "Insufficient Number of arguments"
   exit 0
fi

echo "" >> upgradeLog.log
echo "Upgrading DB Fireman 1.3  to 1.4" >> upgradeLog.log
date >> upgradeLog.log
echo "" >> upgradeLog.log

dbName=$1
mysqlRootPassword=$2

##################################
## Change ACL_entries
#

#Check if version in DB is really corresponding to 1.1 (ACL_entries)
checkingPermField=`mysql -u root -p$mysqlRootPassword -e "DESCRIBE ACL_entries" $dbName | grep perm | awk '{print $1}'`
if [ "$checkingPermField" == "perm" ]
then
    echo "ACL_entries Version is already updated!!"
else
#Checking entry : pseudo entry to be confirmed and deleted.
#mysql -u root -p$mysqlRootPassword -e "INSERT INTO ACL_entries (principal_id,readPerm,removePerm,writePerm,listPerm,permissionPerm,getMetadataPerm,setMetadataPerm,executePerm) values (228,1,0,0,1,0,1,1,0)" $dbName
#mysql -u root -p$mysqlRootPassword -e "INSERT INTO ACL_entries (principal_id,readPerm,removePerm,writePerm,listPerm,permissionPerm,getMetadataPerm,setMetadataPerm,executePerm) values (117,1,0,0,1,1,0,1,0)" $dbName


 #Rename Old ACL_entries Table
 mysql -u root -p$mysqlRootPassword -e "RENAME TABLE ACL_entries TO ACL_entries_old" $dbName
 echo "Renamed Table ACL_entries" >> upgradeLog.log
 
 #Create upgraded table
 mysql -u root -p$mysqlRootPassword -e "CREATE TABLE ACL_entries (acl_id int(11) UNIQUE NOT NULL auto_increment, principal_id int(11) NOT NULL REFERENCES ACL_principals(principal_id), perm int(2) default NULL, UNIQUE KEY entry (principal_id,perm)) TYPE=InnoDB" $dbName
 echo "Created TABLE ACL_entries" 
 
 #Select everything from old table
 mysql -u root -p$mysqlRootPassword -e "SELECT acl_id, principal_id, readPerm, removePerm, writePerm, listPerm, permissionPerm, getMetadataPerm,setMetadataPerm, executePerm FROM ACL_entries_old" $dbName > ACL_entries.data
 echo "Selected everything"
 #cat BASIC_permissions.data | awk '{ print $1 }' | tail +2 > aclId.temp
 #cat BASIC_permissions.data | awk '{ print $2 }' | tail +2 > principalId.temp
 #cat BASIC_permissions.data | awk '{ print $3 }' | tail +2 > readPerm.temp
 #cat BASIC_permissions.data | awk '{ print $4 }' | tail +2 > removePerm.temp
 #cat BASIC_permissions.data | awk '{ print $5 }' | tail +2 > writePerm.temp
 #cat BASIC_permissions.data | awk '{ print $6 }' | tail +2 > listPerm.temp
 #cat BASIC_permissions.data | awk '{ print $7 }' | tail +2 > permissionPerm.temp
 #cat BASIC_permissions.data | awk '{ print $8 }' | tail +2 > getMetadataPerm.temp
 #cat BASIC_permissions.data | awk '{ print $9 }' | tail +2 > setMetadataPerm.temp
 #cat BASIC_permissions.data | awk '{ print $10 }' | tail +2 > executePerm.temp
 echo "getting ACL_entries.data" 
 for ((sqlCount = 2; sqlCount <= `wc -l ACL_entries.data | awk '{ print $1 }'`; sqlCount++)) {
        echo "Reading Permission"
        perm=`tail +$sqlCount ACL_entries.data | head -n1 | awk '{ print $7*1+$4*2+$3*4+$5*8+$10*16+$6*32+$9*64+$8*128 }'`
	echo "Read Permission: $perm"
 	aclId=`tail +$sqlCount ACL_entries.data | head -n1 | awk '{ print $1 }'`
 	principalId=`tail +$sqlCount ACL_entries.data | head -n1 | awk '{ print $2 }'`
        mysql -u root -p$mysqlRootPassword -e "INSERT INTO ACL_entries (acl_id, principal_id, perm) values ($aclId, $principalId, $perm)" $dbName	
 }
 
 mysql -u root -p$mysqlRootPassword -e "DROP TABLE ACL_entries_old" $dbName >> upgradeLog.log
 
 #Check if version in DB is really corresponding to 1.1 
 checkingUserIdField=`mysql -u root -p$mysqlRootPassword -e "DESCRIBE BASIC_permissions" $dbName | grep userId | awk '{print $1}'`
 
 if [ "$checkingUserIdField" == "userId" ]
 then
     echo "BASIC_permissions Version is already updated!!"
     
 else 
 
  #creating a tmp dir where toV proceed
  mkdir upgrade_tmp
  cd upgrade_tmp
  
  
  ##################################
  ## Change BASIC_permissions
  #
  #Rename Old BasicPermissions Table						    
  mysql -u root -p$mysqlRootPassword -e "RENAME TABLE BASIC_permissions TO BASIC_permissions_old;" $dbName
  echo "Renamed Table Basic_permissions" >> upgradeLog.log 
 
  #Create upgraded table
  mysql -u root -p$mysqlRootPassword -e "CREATE TABLE BASIC_permissions (basic_id int(11) UNIQUE NOT NULL auto_increment, userId int default NULL REFERENCES ACL_principals(principal_id), groupId int default NULL REFERENCES ACL_principals(principal_id), userPerm tinyint(4) UNSIGNED default NULL, groupPerm tinyint(4) UNSIGNED default NULL, otherPerm tinyint(4) UNSIGNED default NULL, UNIQUE KEY entry (userId,groupId,userPerm,groupPerm,otherPerm)) TYPE=InnoDB" $dbName
  echo "Created TABLE BASIC_permissions" >> upgradeLog.log
 
  #Select everything from old table
  mysql -u root -p$mysqlRootPassword -e "SELECT * FROM BASIC_permissions_old;" $dbName > BASIC_permissions.data
  cat BASIC_permissions.data >> upgradeLog.log
  cat BASIC_permissions.data | awk '{ print $1 }' | tail +2 > basicId.temp
  cat BASIC_permissions.data | awk '{ print $2 }' | tail +2 > userName.temp
  cat BASIC_permissions.data | awk '{ print $3 }' | tail +2 > groupName.temp
  cat BASIC_permissions.data | awk '{ print $4 }' | tail +2 > userPerm.temp
  cat BASIC_permissions.data | awk '{ print $5 }' | tail +2 > groupPerm.temp
  cat BASIC_permissions.data | awk '{ print $6 }' | tail +2 > otherPerm.temp
  echo "userNames:" >> upgradeLog.log;
  cat userName.temp >> upgradeLog.log;
  echo "groupPerm:" >> upgradeLog.log;
  cat groupPerm.temp >> upgradeLog.log;
  echo "Got all BASIC_permissions data" >> upgradeLog.log;
 
  for ((sqlCount = 1; sqlCount < `wc -l BASIC_permissions.data | awk '{ print $1}'`; sqlCount++)) {
        userName=`tail +$sqlCount userName.temp | head -n1`
        echo "Inserting $userName into ACL_principals" >> upgradeLog.log
  	mysql -u root -p$mysqlRootPassword -e "INSERT INTO ACL_principals (principalName) values ('$userName')" $dbName
  	groupName=`tail +$sqlCount groupName.temp | head -n1`
  	mysql -u root -p$mysqlRootPassword -e "INSERT INTO ACL_principals (principalName) values ('$groupName')" $dbName
  	echo "[debug] Inserting into ACL_principals (principalName) values('$userName')" >> upgradeLog.log;
  
  	#get userId and groupId
 	#userId
        userId=`mysql -u root -p$mysqlRootPassword -e "SELECT principal_id FROM ACL_principals WHERE principalName='$userName'" $dbName | tail +2 | head -n1`
 	
 	#groupId
 	groupId=`mysql -u root -p$mysqlRootPassword -e "SELECT principal_id FROM ACL_principals WHERE principalName='$groupName'" $dbName | tail +2 | head -n1`
         
        userPerm=`tail +$sqlCount userPerm.temp | head -n1`
 	groupPerm=`tail +$sqlCount groupPerm.temp | head -n1`
 	otherPerm=`tail +$sqlCount otherPerm.temp | head -n1`
 	basicId=`tail +$sqlCount basicId.temp | head -n1`
 	
        mysql -u root -p$mysqlRootPassword -e "INSERT INTO BASIC_permissions (basic_id,userId,groupId,userPerm,groupPerm,otherPerm) values ($basicId,$userId,$groupId,$userPerm,$groupPerm,$otherPerm)" $dbName
 	echo "Inserting Into BASIC_permissions (basic_id,userId,groupId,userPerm,groupPerm,otherPerm) values ($basicId,$userId,$groupId,$userPerm,$groupPerm,$otherPerm)" >> upgradeLog.log
  }
  echo "Moved All BASIC_permissions to new tables";
 
 
 
 
 #Delete old Permissions table
 mysql -u root -p$mysqlRootPassword -e "DROP TABLE BASIC_permissions_old" $dbName >> upgradeLog.log
 
 fi
fi

 ########################################
 ## Insert default values
 #
 	mysql -u root -p$mysqlRootPassword -e "INSERT INTO ACL_principals (principal_id,principalName) VALUES (1,'egee')" $dbName
         mysql -u root -p$mysqlRootPassword -e "INSERT INTO ACL_principals (principal_id,principalName) VALUES (2,'egee-group')" $dbName
         mysql -u root -p$mysqlRootPassword -e "INSERT INTO BASIC_permissions (basic_id,userId,groupId,userPerm,groupPerm,otherPerm) VALUES(1,1,2,63,44,36)" $dbName
         mysql -u root -p$mysqlRootPassword -e "INSERT INTO BASIC_permissions (basic_id,userId,groupId,userPerm,groupPerm,otherPerm) VALUES(2,1,2,63,63,63)" $dbName
 
         mysql -u root -p$mysqlRootPassword -e "INSERT INTO GUID_entries (guid_id,guidName,createTime,modifyTime) VALUES (2,"10000000-0000-0000-0000-000000000001",now(),now())" $dbName
         mysql -u root -p$mysqlRootPassword -e "INSERT INTO GUID_entries (guid_id,guidName,createTime,modifyTime) VALUES (3,"10000000-0000-0000-0000-000000000002",now(),now())" $dbName
         mysql -u root -p$mysqlRootPassword -e "INSERT INTO LFN_dirs (dir_id,dirName,creationTime,guid_id,parentDir) VALUES (2,'/tmp',now(),2,1)" $dbName
         mysql -u root -p$mysqlRootPassword -e "INSERT INTO LFN_dirs (dir_id,dirName,creationTime,guid_id,parentDir) VALUES (3,'/free',now(),3,1)" $dbName
         mysql -u root -p$mysqlRootPassword -e "INSERT INTO GUID_basicPerm (guid_id,basic_id) VALUES (2,2)" $dbName
         mysql -u root -p$mysqlRootPassword -e "INSERT INTO GUID_basicPerm (guid_id,basic_id) VALUES (3,2)" $dbName
         mysql -u root -p$mysqlRootPassword $dbName < addMetadataSchema_1.4.0-2.sql 
 

#Check if version in DB is really corresponding to 1.1 (ACL_entries)
checkingPermField=`mysql -u root -p$mysqlRootPassword -e "DESCRIBE ACL_entries" $dbName | grep perm | awk '{print $1}'`
if [ "$checkingPermField" == "perm" ]
then
    echo "ACL_entries succesfuly updated!!"

#Check if version in DB is really corresponding to 1.1
checkingUserIdField=`mysql -u root -p$mysqlRootPassword -e "DESCRIBE BASIC_permissions" $dbName | grep userId | awk '{print $1}'`

if [ "$checkingUserIdField" == "userId" ]
then
    echo "BASIC_permissions and all depending tables successfully updated!!"
   

 
 #Remove all temporary created files
 #rm userName.temp groupName.temp groupPerm.temp userPerm.temp otherPerm.temp basicId.temp
 #rm BASIC_permissions.data
 mv upgradeLog.log ..
 cd ..
                                                                               #rmdir upgrade_tmp
