echo "*************************************"
echo "* Upgrading"  

if [ $# -ne 2 ]
then
   echo "Insufficient Number of arguments"
   exit 0
fi

echo "" >> upgradeLog.log
echo "Upgrading DB Fireman 1.2  to 1.3" >> upgradeLog.log
date >> upgradeLog.log
echo "" >> upgradeLog.log

dbName=$1
mysqlRootPassword=$2

###########################
# Creating TABLE GLOBAL_attributes

mysql -u root -p$mysqlRootPassword -e "CREATE TABLE GLOBAL_attributes (guid_id int(11) NOT NULL REFERENCES GUID_entries(guid_id), attributeName varchar(250), attributeValue varchar(250), attributeType varchar(100), UNIQUE KEY entry (guid_id,`attributeName`); CREATE INDEX GLOBAL_attributes on GLOBAL_attributes(attributeName);" $dbName

###########################
# Fixing some problems

mysql -u root -p$mysqlRootPassword -e "ALTER TABLE SURL_entries CHANGE surlName surlName TEXT" $dbName
mysql -u root -p$mysqlRootPassword -e "ALTER TABLE LFN_dirs CHANGE dirName dirName TEXT" $dbName

















##################################
## Change ACL_entries
#

#Check if version in DB is really corresponding to 1.1 (ACL_entries)
checkingPermField=`mysql -u root -p$mysqlRootPassword -e "DESCRIBE ACL_entries" $dbName | grep perm | awk '{print $1}'`
if [ "$checkingPermField" == "perm" ]
then
    echo "ACL_entries Version is already updated!!"
else
#Checking entry : pseudo entry to be confirmed and deleted.
#mysql -u root -p$mysqlRootPassword -e "INSERT INTO ACL_entries (principal_id,readPerm,removePerm,writePerm,listPerm,permissionPerm,getMetadataPerm,setMetadataPerm,executePerm) values (228,1,0,0,1,0,1,1,0)" $dbName
#mysql -u root -p$mysqlRootPassword -e "INSERT INTO ACL_entries (principal_id,readPerm,removePerm,writePerm,listPerm,permissionPerm,getMetadataPerm,setMetadataPerm,executePerm) values (117,1,0,0,1,1,0,1,0)" $dbName


 #Rename Old ACL_entries Table
 mysql -u root -p$mysqlRootPassword -e "RENAME TABLE ACL_entries TO ACL_entries_old" $dbName
 echo "Renamed Table ACL_entries" >> upgradeLog.log
 
 #Create upgraded table
 mysql -u root -p$mysqlRootPassword -e "CREATE TABLE ACL_entries (acl_id int(11) UNIQUE NOT NULL auto_increment, principal_id int(11) NOT NULL REFERENCES ACL_principals(principal_id), perm int(2) default NULL, UNIQUE KEY entry (principal_id,perm)) TYPE=InnoDB" $dbName
 echo "Created TABLE ACL_entries" 
 
 #Select everything from old table
 mysql -u root -p$mysqlRootPassword -e "SELECT acl_id, principal_id, readPerm, removePerm, writePerm, listPerm, permissionPerm, getMetadataPerm,setMetadataPerm, executePerm FROM ACL_entries_old" $dbName > ACL_entries.data
 echo "Selected everything"
 #cat BASIC_permissions.data | awk '{ print $1 }' | tail +2 > aclId.temp
 #cat BASIC_permissions.data | awk '{ print $2 }' | tail +2 > principalId.temp
 #cat BASIC_permissions.data | awk '{ print $3 }' | tail +2 > readPerm.temp
 #cat BASIC_permissions.data | awk '{ print $4 }' | tail +2 > removePerm.temp
 #cat BASIC_permissions.data | awk '{ print $5 }' | tail +2 > writePerm.temp
 #cat BASIC_permissions.data | awk '{ print $6 }' | tail +2 > listPerm.temp
 #cat BASIC_permissions.data | awk '{ print $7 }' | tail +2 > permissionPerm.temp
 #cat BASIC_permissions.data | awk '{ print $8 }' | tail +2 > getMetadataPerm.temp
 #cat BASIC_permissions.data | awk '{ print $9 }' | tail +2 > setMetadataPerm.temp
 #cat BASIC_permissions.data | awk '{ print $10 }' | tail +2 > executePerm.temp
 echo "getting ACL_entries.data" 
 for ((sqlCount = 2; sqlCount <= `wc -l ACL_entries.data | awk '{ print $1 }'`; sqlCount++)) {
        echo "Reading Permission"
        perm=`tail +$sqlCount ACL_entries.data | head -n1 | awk '{ print $7*1+$4*2+$3*4+$5*8+$10*16+$6*32+$9*64+$8*128 }'`
	echo "Read Permission: $perm"
 	aclId=`tail +$sqlCount ACL_entries.data | head -n1 | awk '{ print $1 }'`
 	principalId=`tail +$sqlCount ACL_entries.data | head -n1 | awk '{ print $2 }'`
        mysql -u root -p$mysqlRootPassword -e "INSERT INTO ACL_entries (acl_id, principal_id, perm) values ($aclId, $principalId, $perm)" $dbName	
 }
 
                                                                               #rmdir upgrade_tmp
